unit comandi;

interface


uses  stringhe,ambienti,termini,crt;

     type    etichetta = char;
                codice_comando = (assegna, ifeq, ifgt,iflt,ifempty, b_goto, b_push, b_top, b_pop, b_input, b_output, nop);
                jumptable = array[0..25] of integer;

        type  comando = object
              cod:  codice_comando;
              id1, id2: varide;
              exp:  termine;
              et:   etichetta;
              procedure newcom;
              end;


              istruzione = object
                et:  etichetta;
                com: comando;
                end;

const max_lun_prog = 1000;

type programma = array[0..max_lun_prog] of istruzione;

procedure prg (l: linea; var i: integer; var b: boolean);

procedure istr (l: linea; var i: integer; var b: boolean);

procedure com (l: linea; var i: integer; var b: boolean);

function lab (l: linea; var i: integer; var b: boolean): etichetta;

function varid (l: linea; var i: integer; var b: boolean): varide;

procedure errore (l: linea; i: integer; testo: string; var  b: boolean);

procedure stampa_comando(i : integer);

var prog : programma;
    pc   : integer;
    jmptbl : jumptable;

implementation

procedure comando.newcom;
  begin
         cod:=nop;
             id1:=chr(0);
             id2:=chr(0);
             exp:=NIL;
             et:=chr(0);
        end;


procedure errore (l: linea; i: integer; testo: string; var b : boolean);
var x: integer;
    c: char;
begin
 if b then
  begin
     writeln('Errore:');
     writeln(l);
     for x:=1 to i-1 do write(' ');
     writeln('^');
     for x:=1 to i-1 do write(' ');
     writeln(chr(192),':',testo);
     b:=false;
     c:=ReadKey;
  end;
end;

procedure stampa_comando(i : integer);
begin

if ((ord(prog[i].et)>=ord('A')) and  (ord(prog[i].et) <= ord('Z'))) then
   write(prog[i].et,':','    ')
else write('      ');

with prog[i].com do begin
case cod of
assegna   :    begin write( id1,' := '); stampa_termine(exp); end;
ifeq      :    write('if ',id1,' = ',id2,' then ',et);
ifgt      :    write('if ',id1,' > ',id2,' then ',et);
iflt      :    write('if ',id1,' < ',id2,' then ',et);
ifempty   :    write('if empty then ',et);
b_goto    :    write('goto ',et);
b_push    :    begin write('push ');stampa_termine(exp); end;
b_top     :    write('top ',id1);
b_pop     :    write('pop ');
b_input   :    write('input ',id1);
b_output  :    begin write('output ');stampa_termine(exp); end;
nop       :    write('NOP');
  end;
 end;
end;


function lab (l: linea; var i: integer; var b: boolean): etichetta;
begin
b:=false;
lab:=chr(0);
 if((ord(l[i])>=ord('A')) and  (ord(l[i]) <= ord('Z'))) then begin
     lab:= l[i];
     b:=true;
     inc(i);
     end
 else errore(l,i,'LABEL expected',b);

end;

function varid (l: linea; var i: integer; var b: boolean): varide;
begin
b:=false;
varid:=chr(0);
 if((ord(l[i])>=ord('a')) and  (ord(l[i]) <= ord('z'))) then begin
     varid:= l[i];
     b:=true;
     inc(i);
     end
 else errore(l,i,'VAR expected',b);
end;

procedure  com(l: linea; var i: integer;  var b: boolean);
begin
 b:=true;
 if (not pre(l,i)) then  b := false
     else
         begin
     if match('if',l,i) then
           if match('emptythen',l,i) then
             begin                                { begin if empty }
             prog[pc].com.cod:=ifempty;
             prog[pc].com.et:=lab(l,i,b);
             end                                  { end empty }
           else if ident(l[i]) then
               begin                          { if 'if var' }
                 prog[pc].com.id1:=varid(l,i,b);
                  case  l[i] of

                   '=' :     begin inc(i);prog[pc].com.cod:=ifeq; end;
                   '>' :     begin inc(i);prog[pc].com.cod:=ifgt; end;
                   '<' :     begin inc(i);prog[pc].com.cod:=iflt; end;

                   else  errore(l,i,'operatore relazionale expected',b);
                   end;                               { case }
                    prog[pc].com.id2:=varid(l,i,b);
                    if match('then',l,i) then
                         prog[pc].com.et:=lab(l,i,b)
                      else errore(l,i,'then expected',b);
                 end
                 else  errore (l,i,'id variabile expected',b)
         else
         if match('goto',l,i)   then begin
            prog[pc].com.cod:=b_goto;
            prog[pc].com.et:=lab(l,i,b);
            end
         else if match('push',l,i)   then begin
            prog[pc].com.cod:=b_push;
            prog[pc].com.exp:=leggi_termine(l,i,b);
            end
         else if match('top',l,i)    then begin
            prog[pc].com.cod:=b_top;
            prog[pc].com.id1:=varid(l,i,b);
            end
         else if match('pop',l,i)    then
            prog[pc].com.cod:=b_pop
         else if match('input',l,i)  then
           begin
            prog[pc].com.cod:=b_input;
            if ident(l[i]) then 
                 prog[pc].com.id1:=varid(l,i,b)
             else errore(l,i,'id variabile expected',b);
            end
         else if match('output',l,i) then begin
            prog[pc].com.cod:=b_output;
            prog[pc].com.exp:=leggi_termine(l,i,b);
            end
         else if ident(l[i]) then
              begin
                prog[pc].com.id1:=varid(l,i,b);
                prog[pc].com.cod:=assegna;
                if (match(':=',l,i)) then
                   prog[pc].com.exp:=leggi_termine(l,i,b)
                   else  errore(l,i,' := expected',b);
              end
         else begin
              b:=false;
              errore(l,i,'sintax errror in expression',b);
              prog[pc].com.cod:=nop;              
              end;

    end;                    { end  if case }


end;            { end  com }


procedure istr (l: linea; var i: integer; var b: boolean);
{  ISTR::= COM|LAB|COM  }
begin
b:=true;
prog[pc].et:=chr(0);
if (not pre(l,i)) then  b := false
     else begin
     if ((ord(l[i])>=ord('A')) and  (ord(l[i]) <= ord('Z'))) then begin  { LAB:COM }
        prog[pc].et:=l[i];
        jmptbl[(ord(l[i])-ord('A'))]:=pc;
        inc(i);
        if(l[i] <>':') then errore(l,i,': expectded ',b) else
        inc(i);
        end;
     com(l,i,b);
     if b then inc (pc)     { incrementa il program counter }
        else errore(l,i,'invalid command ',b)
     end;
end;             { end istr }


procedure prg (l: linea; var i: integer; var b: boolean);
{ PRG::= ISTR| ISTR;PRG }
begin
b:=true;
 if pre(l,i) and b then
 begin
  istr(l,i,b);
  if (pre(l,i) and b and (l[i]= ';')) then begin
     inc(i);
     prg(l,i,b);
     end;
    if not b then errore(l,i,'invalid istructions ',b)
 end;
end;             { end istr }

end.  { implementation }

