unit termini;

interface

uses stringhe, ambienti;

type { comandi = {assegnamento,ifeq,ifgt,ifle,bgotolab,push,top,pop,binput,boutput);}
      codice_expr = (variabile, costante, minus, somma, differenza,
                     prodotto, divisione, modulo, indef);

                    {minus e' il codice del '-' unario;}
                    {indef e' il codice che si usa in caso d'errore}
    termine = ^expr;
    expr = record
        ce: codice_expr;
        ide: varide;           {identificatore della variabile da eguagliare a intero }
        val: integer;          {valore della costante}
        arg1, arg2: termine    {argomenti dell'operatore}
      end;



function ident (c: char): boolean;
{post: true se c in 'a'..'z', i.e. e' ident. di variabile}

function nuovo_termine : termine;
{ ritorna il puntatore ad un nuovo termine inizializzato }

function leggi_termine (l: linea; var i: integer; var b: boolean): termine;
{pre:  i <= lun(l) }
{post: se b = true e l[i..lun(l)] inizia con un termine, ritorna}
{      il puntatore alla sua rappresentazione interna in forma di}
{      albero, avanzando i su l. In caso d'errore pone b:= false}

procedure stampa_termine (t: termine);
{pre:  t <> nil rappr. internamente un termine ben formato}
{post: stampa a video la rappr. esterna del termine la cui}
{      rappr. interna e' l'albero t }

function eval_term (t: termine; a: ambiente; var b: boolean): integer;
{pre:  t <> nil rappr. internamente un termine ben formato}
{post: ritorna il valore nell'ambiente a del termine la cui}
{      rappr. interna e' l'albero t. b e'posta a false e}
{      si ritorna 0 in caso di divisione per 0}

function pre (l :linea; i: integer) : boolean;

function op(l:linea;var i:integer;var b:boolean): codice_expr;

implementation

function pre (l :linea; i: integer) : boolean;
begin
if i >length(l) then  pre := false
else pre:=true;
end;

function ident (c: char): boolean;
{post: true se c in 'a'..'z', i.e. e' ident. di variabile}
begin
 ident:=((ord(c)>=ord('a')) and  (ord(c) <= ord('z')));
end;

function num(l: linea; var i: integer; var n: integer): boolean;
begin
n:=0;
num:=false;
        while (ord(l[i])>=ord('0')) and (ord(l[i])<=ord('9')) and (i <= length(l)) do begin
         n:=(n*10)+(ord(l[i])-ord('0'));
         num:=true;
         inc(i);
         end;

end;

function nuovo_termine: termine;
var t:termine;
begin
t:=new(termine);
t^.ce:=indef;
t^.arg1:=NIL;t^.arg2:=NIL;
nuovo_termine:=t;
end;


function leggi_termine (l: linea; var i: integer; var b: boolean): termine;
{pre:  i <= lun(l) }
{post: se b = true e l[i..lun(l)] inizia con un termine, ritorna}
{      il puntatore alla sua rappresentazione interna in forma di}
{      albero, avanzando i su l. In caso d'errore pone b:= false}

var ex : termine;
    n  : integer;
begin

b:=true;
  if (not pre(l,i)) then  b := false
     else
         begin
         ex := nuovo_termine;
         leggi_termine:=ex;
         if (ident(l[i])) then  begin
              leggi_termine := ex;
              ex^.ide:=l[i];
              ex^.ce:=variabile;
              inc(i);
              end
         else if num(l,i, n) then begin
              ex^.val:=n;
              ex^.ce:=costante;
              end
         else if ( pre(l,i+1) and (l[i]='(') and (l[i+1]='-')) then begin
              i:=i+2;
              ex^.arg1:=leggi_termine(l,i,b);
              ex^.ce:=minus;
              if l[i] = ')' then inc(i) else b:=false;
              end
         else if ( l[i]='(' ) then begin
              inc(i);
              ex^.arg1:=leggi_termine(l,i,b);
              if b then
              ex^.ce:=op(l,i,b);
              if b then
              ex^.arg2:=leggi_termine(l,i,b);
              if l[i] = ')' then inc(i) else b:=false;
              end
        end;

end;                    { end leggi_termine }

function op(l:linea;var i:integer;var b:boolean):codice_expr;
begin
op:=indef;
case l[i] of
 '+' : begin op:=somma;         inc(i); end;
 '-' : begin op:=differenza;    inc(i); end;
 '*' : begin op:=prodotto;      inc(i); end;
 else
    if match('mod',l,i) then op:=modulo else
    if match('div',l,i) then op:=divisione;
 end;

end;

procedure stampa_termine (t: termine);
{pre:  t <> nil rappr. internamente un termine ben formato}
{post: stampa a video la rappr. esterna del termine la cui}
{      rappr. interna e' l'albero t }
begin
if t= NIL then writeln('ERRORE: ESPRESSIONE NON CORRETTA');
case t^.ce of

     variabile  : write(t^.ide);
     costante   : write(t^.val);
     minus      : begin
                   write('(-');
                   stampa_termine(t^.arg1);
                   write(')');
                  end;
     somma      : begin
                   write('(');
                   stampa_termine(t^.arg1);
                   write('+');
                   stampa_termine(t^.arg2);
                   write(')');
                  end;
     differenza : begin
                   write('(');
                   stampa_termine(t^.arg1);
                   write('-');
                   stampa_termine(t^.arg2);
                   write(')');
                  end;
     prodotto   : begin
                   write('(');
                   stampa_termine(t^.arg1);
                   write('*');
                   stampa_termine(t^.arg2);
                   write(')');
                  end;
     modulo     : begin
                   write('(');
                   stampa_termine(t^.arg1);
                   write(' mod ');
                   stampa_termine(t^.arg2);
                   write(')');
                  end;
     divisione  : begin
                   write('(');
                   stampa_termine(t^.arg1);
                   write(' div ');
                   stampa_termine(t^.arg2);
                   write(')');
                  end;
         else  writeln('ERRORE: ESPRESSIONE NON VALIDA');
   end; { end case }


end;


function eval_term (t: termine; a: ambiente; var b: boolean): integer;
var n,d: integer;
begin
b:=true;
case t^.ce of

     variabile  : eval_term:=eval_var(t^.ide,a);
     costante   : eval_term:=t^.val;
     minus      : eval_term:=-eval_term(t^.arg1,a,b);
     somma      : eval_term:=eval_term(t^.arg1,a,b) + eval_term(t^.arg2,a,b);
     differenza : eval_term:=eval_term(t^.arg1,a,b) - eval_term(t^.arg2,a,b);
     prodotto   : eval_term:=eval_term(t^.arg1,a,b) * eval_term(t^.arg2,a,b);
     modulo     : begin
                  n:=eval_term(t^.arg1,a,b);
                  d:=eval_term(t^.arg2,a,b);
                  if d <> 0 then eval_term :=(n mod d)
                     else eval_term := 0;
                  end;

     divisione  : begin
                  n:=eval_term(t^.arg1,a,b);
                  d:=eval_term(t^.arg2,a,b);
                  if d <> 0 then eval_term :=(n div d)
                     else eval_term := 0;
                  end
    else  b:=false;

 end; { end case }
end;
end.



